function [outputCell]=ita_v2laboratory_gui_abai()

% <ITA-Toolbox>
% This file is part of the application Laboratory for the ITA-Toolbox. All rights reserved.
% You can find the license for this m-file in the application folder.
% </ITA-Toolbox>

%% generate GUI
scrennSize = get(0,'ScreenSize');
centerOfGUI = scrennSize(3:4)/2;        %central point of screen
layout.figSize          = [800 550];    %size of figure
layout.defaultSpace     = 20;
layout.compTxtHeight    = 12;           %standart text height
layout.compBTxtHeight   = 10;           %standart button text height
layout.editBTxtHeight   = 9;
layout.bSize           = [120 20];      %standart button size
layout.bPosition       = [layout.figSize(1)/2-170 layout.figSize(2) - 2*layout.defaultSpace-layout.compTxtHeight-layout.bSize(2) layout.bSize; layout.figSize(1)/2+170-120 layout.figSize(2)-2*layout.defaultSpace-layout.compTxtHeight-layout.bSize(2) layout.bSize];
layout.bgColor=[0.8 0.8 0.8];       %standart background color
layout.wsColor=[1.0 1.0 1.0];       %weisse background
layout.fontColor='blue';            %standart text color
layout.editColor='black';
%             handles.output = hObject;
%             guidata(hObject, handles);
%                 function varargout = ita_v2laboratory_gui_abai_OutputFcn(hObject, eventdata, handles)
%                     varargout{1} = handles.output;
h.outputCell = []; % variable for output

dataPath = fullfile(fileparts(ita_toolbox_path), sprintf('Laboratory_V2_%s', datestr(now, 'yyyy-mm-dd')));


%creating figure
h.MainFigure = figure('Visible','on',...
    'NumberTitle', 'off',...
    'Position',[centerOfGUI(1)-layout.figSize(1)/2,centerOfGUI(2)-layout.figSize(2)/2, layout.figSize],...
    'Name','Versuch 2',...
    'MenuBar', 'none',...
    'Color', layout.bgColor);
% creating headline
h.txtHeadline = uicontrol('Style','text',...
    'String','Laboratory: sound insulation parameter box',...
    'FontWeight','bold',...
    'ForegroundColor','black',...
    'BackgroundColor',layout.bgColor,...
    'FontSize',15,...
    'Position',[0,layout.figSize(2)-layout.defaultSpace-1.5*layout.compTxtHeight,layout.figSize(1),2*layout.compTxtHeight],...
    'horizontalAlignment','center');
%creating line
h.line1 = uicontrol('Position',[0, layout.figSize(2)-layout.defaultSpace-2*layout.defaultSpace layout.figSize(1) 1],...
    'BackgroundColor',layout.bgColor,...
    'HorizontalAlignment','left',...
    'Style', 'frame');

%--------------------------------------------------------------------------
% Material ID
%--------------------------------------------------------------------------
%creating text for Element1
h.MatID_txt = uicontrol('Style','text',...
    'String','Material ID',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-5*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%creating edit for Element1
h.MatID_edit = uicontrol('Style','edit',...
    'String','1',...
    'FontWeight','bold',...
    'HorizontalAlignment','right',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-5*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@MatID_edit_Callback});
%--------------------------------------------------------------------------
% Material
%--------------------------------------------------------------------------
%creating text for Element2
h.Material_txt = uicontrol('Style','text',...
    'String','Material',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-7*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');

%creating popup menu for Element2
h.Material_popUp = uicontrol('Style','popupmenu',...
    'String',{'MDF';'MDF double plate';'Aluminium';'Brass'; 'Plate with opening area'},...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-7*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'Callback',{@Material_popUp_Callback});

%--------------------------------------------------------------------------
% Thickness I
%--------------------------------------------------------------------------
%creating text for Element3
h.Thickness_1_txt = uicontrol('Style','text',...
    'String','Thickness I',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-9*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
% Unit for plate 1
h.txtUnitPlate_1 = uicontrol('Style','text',...
    'String','mm',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[24*layout.defaultSpace,layout.figSize(2)-9*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%creating edit for Element3
h.Thickness_1_edit = uicontrol('Style','edit',...
    'String','4',...
    'FontWeight','bold',...
    'HorizontalAlignment','right',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-9*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@Thickness_1_edit_Callback});
%--------------------------------------------------------------------------
% Thickness II
%--------------------------------------------------------------------------
%creating text thickness plate
h.Thickness_2_txt = uicontrol('Style','text',...
    'String','Thickness II',...
    'FontWeight','bold',...
    'Visible', 'off',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-11*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%creating edit for Element4
h.Thickness_2_edit = uicontrol('Style','edit',...
    'String','8',...
    'FontWeight','bold',...
    'HorizontalAlignment','right',...
    'Visible', 'off',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-11*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@Thickness_2_edit_Callback});
% Unit for plate 2
h.txtUnitPlate_2 = uicontrol('Style','text',...
    'String','mm',...
    'FontWeight','bold',...
    'Visible', 'off',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[24*layout.defaultSpace,layout.figSize(2)-11*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%--------------------------------------------------------------------------
% Thickness III
%--------------------------------------------------------------------------
%creating text for Element5
h.Thickness_3_txt = uicontrol('Style','text',...
    'String','Thickness Air',...
    'FontWeight','bold',...
    'Visible', 'off',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-13*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%creating edit for Element5
h.Thickness_3_edit = uicontrol('Style','edit',...
    'String','8',...
    'FontWeight','bold',...
    'HorizontalAlignment','right',...
    'Visible', 'off',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-13*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@Thickness_3_edit_Callback});

% Unit for air
h.txtUnitPlate_3 = uicontrol('Style','text',...
    'String','mm',...
    'FontWeight','bold',...
    'Visible', 'off',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[24*layout.defaultSpace,layout.figSize(2)-13*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
h.txtUnitPlate_3 = uicontrol('Style','text',...
    'String','mm',...
    'FontWeight','bold',...
    'Visible', 'off',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[24*layout.defaultSpace,layout.figSize(2)-13*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%--------------------------------------------------------------------------
% Opening area
%--------------------------------------------------------------------------
h.OpenArea_txt = uicontrol('Style','text',...
    'String','Opening area',...
    'FontWeight','bold',...
    'Visible', 'off',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-15*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');


%creating edit for Element5
h.OpenArea_edit = uicontrol('Style','edit',...
    'String','0',...
    'FontWeight','bold',...
    'Visible', 'off',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-15*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@OpenArea_edit_Callback});

h.txtUnitOpen = uicontrol('Style','text',...
    'String','mm',...
    'FontWeight','bold',...
    'Visible', 'off',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[24*layout.defaultSpace,layout.figSize(2)-15*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%--------------------------------------------------------------------------
% Density
%--------------------------------------------------------------------------
%creating text for Element6
h.Density_txt = uicontrol('Style','text',...
    'String','Density of material',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-17*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');

% Unit Density
h.txtUnitDensity = uicontrol('Style','text',...
    'String','kg/m',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[24*layout.defaultSpace,layout.figSize(2)-17*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');

%creating edit for Element6
h.Density_edit = uicontrol('Style','edit',...
    'String','618',...
    'FontWeight','bold',...
    'HorizontalAlignment','right',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-17*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@Density_edit_Callback});
%--------------------------------------------------------------------------
% Young's modulus
%--------------------------------------------------------------------------
%creating text for Element7
h.YoungsM_txt = uicontrol('Style','text',...
    'String','Young''s modulus',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-19*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%creating edit for Element7
h.YoungsM_edit = uicontrol('Style','edit',...
    'String','3.2',...
    'FontWeight','bold',...
    'HorizontalAlignment','right',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-19*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@YoungsM_edit_Callback});
% Unit younth's modulus
h.txtUnitYoungthsMod = uicontrol('Style','text',...
    'String','G Pa',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[24*layout.defaultSpace,layout.figSize(2)-19*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%--------------------------------------------------------------------------
% Signal length
%--------------------------------------------------------------------------
%creating text for Element8
h.SignalL_txt = uicontrol('Style','text',...
    'String','Signal length 2^x',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-21*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%creating edit for Element8
h.SignalL_edit = uicontrol('Style','edit',...
    'String','16',...
    'FontWeight','bold',...
    'HorizontalAlignment','right',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-21*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@SignalL_edit_Callback});
%--------------------------------------------------------------------------
% Number of sources
%--------------------------------------------------------------------------
%creating text for Element9
h.NumSource_txt = uicontrol('Style','text',...
    'String','No. of Sources',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-23*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%creating edit for Element9
h.NumSource_edit = uicontrol('Style','edit',...
    'String','1',...
    'FontWeight','bold',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-23*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{@NumSource_edit_Callback});
%--------------------------------------------------------------------------
% Path
%--------------------------------------------------------------------------
%creating text for Element10
h.Path_txt = uicontrol('Style','text',...
    'String','Path',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.compTxtHeight,...
    'Position',[layout.defaultSpace,layout.figSize(2)-25*layout.defaultSpace,layout.figSize(1)/2,2*layout.compTxtHeight],...
    'horizontalAlignment','left');
%creating edit for Element10
h.Path_edit = uicontrol('Style','edit',...
    'String',dataPath,...
    'FontWeight','bold',...
    'ForegroundColor',layout.editColor,...
    'BackgroundColor',layout.wsColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*12,layout.figSize(2)-25*layout.defaultSpace,layout.figSize(1)/4,2*layout.compTxtHeight],...
    'horizontalAlignment','right',...
    'Callback',{});
%creating pushbutton for Path
h.pushButPath = uicontrol('Style','pushbutton',...
    'String','...',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*25,layout.figSize(2)-25*layout.defaultSpace,layout.figSize(1)/7,2*layout.compTxtHeight],...
    'horizontalAlignment','center',...
    'Callback',{@pathButton_Callback});
%--------------------------------------------------------------------------
% Finish
%--------------------------------------------------------------------------
%creating CancelButton
h.CancelBut = uicontrol('Style','pushbutton',...
    'String','Cancel',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*25,layout.figSize(2)-27*layout.defaultSpace,layout.figSize(1)/7,2*layout.compTxtHeight],...
    'horizontalAlignment','center',...
    'Callback',{@CancelBut_Callback,h});
%creating OkButton
h.OkBut = uicontrol('Style','pushbutton',...
    'String','OK',...
    'FontWeight','bold',...
    'ForegroundColor',layout.fontColor,...
    'BackgroundColor',layout.bgColor,...
    'FontSize',layout.editBTxtHeight,...
    'Position',[layout.defaultSpace*32,layout.figSize(2)-27*layout.defaultSpace,layout.figSize(1)/7,2*layout.compTxtHeight],...
    'horizontalAlignment','center',...
    'Callback',{@OkBut_Callback});

guidata(h.MainFigure, h);

uiwait()%wait for Gui Data
if  ishandle(h.MainFigure)
    handles = guidata(h.MainFigure);%Struct von GUI handles
    outputCell = handles.outputCell; %all in outputCell
    close(h.MainFigure);
else
    outputCell=false;
end


end

%==========================================================================
% Path callback
%==========================================================================
function pathButton_Callback(hObject, ~)
handles = guidata(hObject);
[pathname]=uigetdir('C:','Please choose your path');
if ischar(pathname)
    path=fullfile(pathname);
    set(handles.Path_edit,'String',path);
end
% if filename ~=0
%     load(fullfile(pathname));

%end
end


%==========================================================================
% Material popup callback
%==========================================================================
function Material_popUp_Callback(hObject, ~)
handles = guidata(hObject);
index = get(handles.Material_popUp, 'Value');
switch index
    case {1,3,4},
        set(handles.Thickness_2_txt, 'Visible', 'off');
        set(handles.Thickness_2_edit, 'Visible', 'off');
        set(handles.Thickness_2_edit,'String','0');
        set(handles.txtUnitPlate_2, 'Visible', 'off');
        
        set(handles.Thickness_3_edit, 'Visible', 'off');
        set(handles.Thickness_3_txt, 'Visible', 'off');
        set(handles.txtUnitPlate_3, 'Visible', 'off');
        set(handles.Thickness_3_edit,'String','0');
        
        set(handles.OpenArea_edit, 'Visible', 'off');
        set(handles.OpenArea_txt, 'Visible', 'off');
        set(handles.txtUnitOpen, 'Visible', 'off');
        set(handles.OpenArea_edit,'String','0');
    case {2},
        set(handles.Thickness_2_txt, 'Visible', 'on');
        set(handles.Thickness_2_edit, 'Visible', 'on');
        set(handles.txtUnitPlate_2, 'Visible', 'on');
        set(handles.Thickness_2_edit,'String','1');
        
        set(handles.Thickness_3_edit, 'Visible', 'on');
        set(handles.Thickness_3_txt, 'Visible', 'on');
        set(handles.txtUnitPlate_3, 'Visible', 'on');
        set(handles.Thickness_3_edit,'String','1');
        
        set(handles.txtUnitOpen, 'Visible', 'off');
        set(handles.OpenArea_txt, 'Visible', 'off');
        set(handles.OpenArea_edit, 'Visible', 'off');
        set(handles.OpenArea_edit, 'String', '0');
        
    case {5},
        set(handles.Thickness_2_txt, 'Visible', 'off');
        set(handles.Thickness_2_edit, 'Visible', 'off');
        set(handles.Thickness_2_edit,'String','0');
        set(handles.txtUnitPlate_2, 'Visible', 'off');
        
        set(handles.Thickness_3_edit, 'Visible', 'off');
        set(handles.Thickness_3_txt, 'Visible', 'off');
        set(handles.txtUnitPlate_3, 'Visible', 'off');
        set(handles.Thickness_3_edit,'String','0');
        
        set(handles.txtUnitOpen, 'Visible', 'on');
        set(handles.OpenArea_txt, 'Visible', 'on');
        set(handles.OpenArea_edit, 'Visible', 'on');
        set(handles.OpenArea_edit, 'String', '1000');
end
end
%==========================================================================
% OK Button callback
%==========================================================================
function OkBut_Callback(hObject, ~)
% Werte abspeichern
handles = guidata(hObject);
group = str2double(get(handles.MatID_edit,'String'));%1
allMaterialCell = get(handles.Material_popUp,'String');

Material = allMaterialCell{get(handles.Material_popUp,'value')};%2
thickness = str2double(get(handles.Thickness_1_edit,'String'));%3
thickness2 = str2double(get(handles.Thickness_2_edit,'String')); %4
luft_thickness = str2double(get(handles.Thickness_3_edit,'String'));%5
density = str2double(get(handles.Density_edit,'String'));%6
YoungsModulus = str2double(get(handles.YoungsM_edit,'String'));%7
fftDegree = str2double(get(handles.SignalL_edit,'String'));%8
noOfSource = str2double(get(handles.NumSource_edit,'String'));%9
pathOf = get(handles.Path_edit,'String');%10
offFlaeche = str2double(get(handles.OpenArea_edit,'String'));%11
handles.outputCell = {group, Material, thickness, thickness2,...
    luft_thickness, density, YoungsModulus,...
    fftDegree, noOfSource, pathOf, offFlaeche};

for i1 = 1:length(handles.outputCell)
    if isnan(handles.outputCell{i1})
        handles.outputCell = false;
        break;
    end
end

guidata(hObject, handles);
if length(handles.outputCell)~=1
    uiresume()
end
end
%==========================================================================
%Cancel Button
%==========================================================================
function CancelBut_Callback(hObject, ~,h)
handles = guidata(hObject);
handles.outputCell = {};
guidata(hObject, handles);
uiresume()
end
%==========================================================================
% Material ID callback
%==========================================================================
function MatID_edit_Callback (hObject, ~)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end
%==========================================================================
% Thickness I callback
%==========================================================================
function Thickness_1_edit_Callback (hObject, ~)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end
%==========================================================================
% Thickness II callback
%==========================================================================
function Thickness_2_edit_Callback (hObject, ~)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end
%==========================================================================
% Thickness III callback
%==========================================================================
function Thickness_3_edit_Callback (hObject, eventdata)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end
%==========================================================================
% Density callback
%==========================================================================
function Density_edit_Callback (hObject, eventdata)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end
%==========================================================================
% Young's modulus callback
%==========================================================================
function YoungsM_edit_Callback (hObject, eventdata)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end
%==========================================================================
% Signal length callback
%==========================================================================
function SignalL_edit_Callback (hObject, eventdata)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end
%==========================================================================
% Number of sources callback
%==========================================================================
function NumSource_edit_Callback (hObject, eventdata)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end
%==========================================================================
% opening area callback
%==========================================================================
function OpenArea_edit_Callback (hObject, eventdata)
user_entry = str2double(get(hObject,'String'));
set(hObject, 'String',user_entry);
if isnan (user_entry)
    errordlg ('Please correct you choice', 'Bad Input', 'modal')
    set(hObject,'ForegroundColor','red');
else
    set(hObject,'ForegroundColor','black');
end
end

