function [h]=vol_hex_basis_fct(r,s,t)
% Basisfunctions for volume hexaeder
%                                           node | ri| si| ti
%----------------------------------------------------------------------

% <ITA-Toolbox>
% This file is part of the application FluidFEM for the ITA-Toolbox. All rights reserved.
% You can find the license for this m-file in the application folder.
% </ITA-Toolbox>

h(1)= 1/8*(1+r)*(1-s)*(1+t)*(r-s+t-2);      % 1	 1	-1	 1
h(2)= 1/4*(1-r^2)*(1+t)*(1-s);              % 2	 0	-1	 1
h(3)= 1/8*(1-r)*(1-s)*(1+t)*(-r-s+t-2); 	% 3 -1	-1	 1
h(4)= 1/4*(1-s^2)*(1+t)*(1-r);              % 4	-1	 0	 1
h(5)= 1/8*(1-r)*(1+s)*(1+t)*(-r+s+t-2); 	% 5	-1	 1	 1
h(6)= 1/4*(1-r^2)*(1+t)*(1+s);              % 6	 0	 1	 1
h(7)= 1/8*(1+r)*(1+s)*(1+t)*(r+s+t-2);      % 7	 1	 1	 1
h(8)= 1/4*(1-s^2)*(1+t)*(1+r);              % 8	 1	 0	 1
h(9)= 1/4*(1-t^2)*(1-s)*(1+r);              % 9	 1	-1	 0
h(10)= 1/4*(1-t^2)*(1-s)*(1-r);             %10	-1	-1	 0
h(11)= 1/4*(1-t^2)*(1+s)*(1-r);             %11	-1	 1	 0
h(12)= 1/4*(1-t^2)*(1+s)*(1+r);             %12	 1	 1	 0
h(13)= 1/8*(1+r)*(1-s)*(1-t)*(r-s-t-2);     %13	 1	-1	-1
h(14)= 1/4*(1-r^2)*(1-t)*(1-s);             %14	 0	-1	-1
h(15)= 1/8*(1-r)*(1-s)*(1-t)*(-r-s-t-2);	%15	-1	-1	-1
h(16)= 1/4*(1-s^2)*(1-t)*(1-r);             %16	-1	 0	-1
h(17)= 1/8*(1-r)*(1+s)*(1-t)*(-r+s-t-2);	%17	-1	 1	-1
h(18)= 1/4*(1-r^2)*(1-t)*(1+s);             %18  0	 1	-1
h(19)= 1/8*(1+r)*(1+s)*(1-t)*(r+s-t-2);     %19	 1	 1	-1
h(20)= 1/4*(1-s^2)*(1-t)*(1+r);             %20	 1	 0	-1