function [h] = vol_hex_nbasis_fct(r,s,t)
% Function gives derivations of basis function back and gets the supporting
% points (r,s,t).

% <ITA-Toolbox>
% This file is part of the application FluidFEM for the ITA-Toolbox. All rights reserved.
% You can find the license for this m-file in the application folder.
% </ITA-Toolbox>


% numberation:
% h(x,:) derivations of the basisfunction x
% h(:,1) = dh/dr,  h(:,2) = dh/ds,  h(:,3) = dh/dt
% -------------------------------------------------------------------------
h(1,1)=   1/8*(1-s)*(1+t)*(2*r-s+t-1);
h(1,2)=  -1/8*(1+r)*(1+t)*(-2*s+r+t-1);
h(1,3)=   1/8*(1+r)*(1-s)*(2*t+r-s-1); 


h(2,1)= -1/2*r*(1-s)*(1+t);           
h(2,2)= -1/4*(1-r^2)*(1+t);          
h(2,3)= +1/4*(1-r^2)*(1-s);          

h(3,1)= -1/8*(1-s)*(1+t)*(-2*r-s+t-1);
h(3,2)= -1/8*(1-r)*(1+t)*(-2*s-r+t-1);
h(3,3)= +1/8*(1-r)*(1-s)*(2*t-r-s-1); 

h(4,1)= -1/4*(1-s^2)*(1+t);          
h(4,2)= -1/2*s*(1-r)*(1+t);          
h(4,3)= +1/4*(1-s^2)*(1-r);          

h(5,1)= -1/8*(1+s)*(1+t)*(-2*r+s+t-1);
h(5,2)= +1/8*(1-r)*(1+t)*(2*s-r+t-1); 
h(5,3)= +1/8*(1-r)*(1+s)*(2*t-r+s-1);

h(6,1)= -1/2*r*(1+s)*(1+t);          
h(6,2)= +1/4*(1-r^2)*(1+t);         
h(6,3)= +1/4*(1-r^2)*(1+s);         

h(7,1)=   1/8*(1+s)*(1+t)*(2*r+s+t-1);
h(7,2)=  +1/8*(1+r)*(1+t)*(2*s+r+t-1); 
h(7,3)=  +1/8*(1+r)*(1+s)*(2*t+r+s-1);

h(8,1)=   1/4*(1-s^2)*(1+t);         
h(8,2)=  -1/2*s*(1+r)*(1+t);      
h(8,3)=   +1/4*(1-s^2)*(1+r);        

h(9,1)=  1/4*(1-t^2)*(1-s);      
h(9,2)= -1/4*(1-t^2)*(1+r);        
h(9,3)= -1/2*t*(1+r)*(1-s);    

h(10,1)= -1/4*(1-t^2)*(1-s);      
h(10,2)= -1/4*(1-t^2)*(1-r);    
h(10,3)= -1/2*t*(1-r)*(1-s);   

h(11,1)= -1/4*(1-t^2)*(1+s);     
h(11,2)= +1/4*(1-t^2)*(1-r);    
h(11,3)= -1/2*t*(1-r)*(1+s);     

h(12,1)=   1/4*(1-t^2)*(1+s);     
h(12,2)=  +1/4*(1-t^2)*(1+r);         
h(12,3)=  -1/2*t*(1+r)*(1+s);        

h(13,1)=   1/8*(1-s)*(1-t)*(2*r-s-t-1); 
h(13,2)=  -1/8*(1+r)*(1-t)*(-2*s+r-t-1);
h(13,3)=  -1/8*(1+r)*(1-s)*(-2*t+r-s-1);

h(14,1)=  -1/2*r*(1-s)*(1-t);           
h(14,2)=  -1/4*(1-r^2)*(1-t);           
h(14,3)=  -1/4*(1-r^2)*(1-s);          

h(15,1)= -1/8*(1-s)*(1-t)*(-2*r-s-t-1);
h(15,2)= -1/8*(1-r)*(1-t)*(-2*s-r-t-1);
h(15,3)= -1/8*(1-r)*(1-s)*(-2*t-r-s-1);

h(17,1)= -1/8*(1+s)*(1-t)*(-2*r+s-t-1);
h(17,2)= +1/8*(1-r)*(1-t)*(2*s-r-t-1);
h(17,3)= -1/8*(1-r)*(1+s)*(-2*t-r+s-1);

h(16,1)= -1/4*(1-s^2)*(1-t);           
h(16,2)= -1/2*s*(1-r)*(1-t);          
h(16,3)= -1/4*(1-s^2)*(1-r);          

h(18,1)= -1/2*r*(1+s)*(1-t);          
h(18,2)= +1/4*(1-r^2)*(1-t);        
h(18,3)= -1/4*(1-r^2)*(1+s);       


h(19,1)=   1/8*(1+s)*(1-t)*(2*r+s-t-1);
h(19,2)=  +1/8*(1+r)*(1-t)*(2*s+r-t-1); 
h(19,3)=  -1/8*(1+r)*(1+s)*(-2*t+r+s-1);

h(20,1)=   1/4*(1-s^2)*(1-t);    
h(20,2)=  -1/2*s*(1+r)*(1-t);    
h(20,3)=  -1/4*(1-s^2)*(1+r);   


